<?php
global $cjaddons_options;
$file_name = str_replace( '.php', '', basename( __FILE__ ) );
$ticket_variables_content = '';
$variables = array(
	'ticket_variables_html' => '<div class="cj-mt-0 cj-mb-20 cj-text-bold cj-fs-18">Ticket Variables</div>',
	'TICKET_UID' => __( 'Renders ticket unique identifier.', 'addon-supportezzy' ),
	'TICKET_SUBJECT' => __( 'Renders ticket title.', 'addon-supportezzy' ),
	'TICKET_COMMENT' => __( 'Renders ticket content.', 'addon-supportezzy' ),
	'TICKET_URL' => __( 'Renders ticket url.', 'addon-supportezzy' ),
	'TICKET_DEPARTMENT_NAME' => __( 'Renders ticket department name.', 'addon-supportezzy' ),
	'TICKET_PRODUCT_NAME' => __( 'Renders ticket product name.', 'addon-supportezzy' ),
	'TICKET_CLIENT_NAME' => __( 'Renders ticket client full name.', 'addon-supportezzy' ),
	'TICKET_AGENT_NAMES' => __( 'Renders ticket agents full name.', 'addon-supportezzy' ),
	'comment_variables_html' => '<hr><div class="cj-mt-10 cj-mb-20 cj-text-bold cj-fs-18">Comment Variables</div>',
	'COMMENT_CONTENT' => __( 'Renders ticket content.', 'addon-supportezzy' ),
	'COMMENT_AUTHOR_NAME' => __( 'Renders comment author display name.', 'addon-supportezzy' ),
);
foreach( $variables as $key => $value ) {
	if( strpos($key, '_html') > 0 ) {
		$ticket_variables_content .= $value;
	} else {
		$ticket_variables_content .= '<div class="cj-mb-15"><code data-clipboard-text="%%' . $key . '%%" data-clipboard-confirmation="' . __( 'Copied to clipboard!', 'addon-supportezzy' ) . '">%%' . $key . '%%</code><br><span class="cj-inline-block cj-mt-3 cj-opacity-50">' . $value . '</span></div>';
	}
}

$cjaddons_options[ $file_name ] = array(
	array(
		'type' => 'heading',
		'id' => 'cjsupport-email-variables-heading',
		'label' => __( 'Dynamic Variables', 'addon-supportezzy' ),
		'info' => '',
		'suffix' => '',
		'prefix' => '',
		'default' => '',
		'options' => '', // array in case of dropdown, checkbox and radio buttons
	),
	array(
		'type' => 'info',
		'id' => 'cjsupport-email-variables-info',
		'label' => __( 'Variables', 'addon-supportezzy' ),
		'info' => '',
		'suffix' => '',
		'prefix' => '',
		'default' => $ticket_variables_content,
		'options' => '', // array in case of dropdown, checkbox and radio buttons
	),
);