<?php
if( ! class_exists( 'cjaddons_supportezzy_rest_module_info' ) ) {
	class cjaddons_supportezzy_rest_module_info {

		public $helpers, $module_id, $module_dir, $routes, $api_url, $module_info;

		private static $instance;

		public static function getInstance() {
			if( ! isset( self::$instance ) ) {
				self::$instance = new self();
			}

			return self::$instance;
		}

		public function __construct() {
			$this->helpers = cjaddons_supportezzy_helpers::getInstance();
			$this->module_info = $this->helpers->moduleInfo( basename( $this->helpers->module_dir ) );
			$this->module_id = basename( $this->helpers->module_dir );
			$this->api_url = '';
			if( function_exists( 'using_index_permalinks' ) ) {
				$this->api_url = rest_url( 'cjaddons' ) . '/';
			}
			$this->routes = array(
				$this->module_id . '-module-info' => array(
					'endpoint' => $this->module_info['module_id'] . '/module-info',
					'name' => sprintf( __( '%s Add-on Info', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => __( 'Returns add-on info.', 'addon-supportezzy' ),
					'methods' => array(
						'get' => array($this, 'info'), // callback function
						'post' => array($this, 'info'), // callback function
					),
					'permissions' => function () {
						return true;
						// return current_user_can( 'manage_options' );
					},
				),
			);
			add_filter( 'cjaddons_register_api_route', array($this, 'registerRoute') );
		}

		public function registerRoute( $routes ) {
			$routes = array_merge( $routes, $this->routes );

			return $routes;
		}

		public function info( $request ) {
			$api_user_info = $this->helpers->getApiUserInfo( $request );
			$data = $this->helpers->moduleInfo( basename( $this->module_dir ) );
			if( empty( $api_user_info ) ) {
				unset( $data['module_path'] );
			}
			if( ! empty( $api_user_info ) && isset( $api_user_info['roles'] ) && ! in_array( 'administrator', $api_user_info['roles'] ) ) {
				unset( $data['module_path'] );
			}

			return $this->helpers->apiResponse( $request, $data );
		}

	}

	cjaddons_supportezzy_rest_module_info::getInstance();
}