<?php
if( ! class_exists( 'cjaddons_rest_cjsupport_tickets' ) ) {
	class cjaddons_rest_cjsupport_tickets {

		public $helpers, $module_id, $module_dir, $routes, $api_url, $module_info;

		private static $instance;

		public static function getInstance() {
			if( ! isset( self::$instance ) ) {
				self::$instance = new self();
			}

			return self::$instance;
		}

		public function __construct() {
			$this->helpers = cjaddons_supportezzy_helpers::getInstance();
			$this->module_info = $this->helpers->moduleInfo( basename( $this->helpers->module_dir ) );
			$this->module_id = basename( $this->helpers->module_dir );
			$this->api_url = '';
			if( function_exists( 'using_index_permalinks' ) ) {
				$this->api_url = rest_url( 'cjaddons' ) . '/';
			}
			$this->routes = array(
				$this->module_id . '-tickets' => array(
					'endpoint' => $this->module_info['module_id'] . '/tickets',
					'name' => sprintf( __( '%s Login', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => '',
					'methods' => array(
						'post' => array($this, 'getTickets'), // callback function
					),
					'permissions' => function ( $request ) {
						$user = $this->helpers->getApiUserInfo( $request );

						return ( ! empty( $user )) ? true : false;
					},
				),
				$this->module_id . '-ticket' => array(
					'endpoint' => $this->module_info['module_id'] . '/ticket',
					'name' => sprintf( __( '%s Ticket', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => '',
					'methods' => array(
						'post' => array($this, 'getTicket'), // callback function
					),
					'permissions' => function ( $request ) {
						$user = $this->helpers->getApiUserInfo( $request );

						return ( ! empty( $user )) ? true : false;
					},
				),
				$this->module_id . '-ticket-update-data' => array(
					'endpoint' => $this->module_info['module_id'] . '/ticket-update-data',
					'name' => sprintf( __( '%s Update Ticket Meta', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => '',
					'methods' => array(
						'post' => array($this, 'ticketsUpdateData'), // callback function
					),
					'permissions' => function ( $request ) {
						$user = $this->helpers->getApiUserInfo( $request );

						return ( ! empty( $user )) ? true : false;
					},
				),
				$this->module_id . '-ticket-create' => array(
					'endpoint' => $this->module_info['module_id'] . '/ticket-create',
					'name' => sprintf( __( '%s Create ticket', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => '',
					'methods' => array(
						'post' => array($this, 'createTicket'), // callback function
					),
					'permissions' => function ( $request ) {
						return true;
					},
				),
				$this->module_id . '-ticket-star' => array(
					'endpoint' => $this->module_info['module_id'] . '/ticket-star',
					'name' => sprintf( __( '%s Toggle Star', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => '',
					'methods' => array(
						'post' => array($this, 'toggleTicketStars'), // callback function
					),
					'permissions' => function ( $request ) {
						$user = $this->helpers->getApiUserInfo( $request );

						return ( ! empty( $user )) ? true : false;
					},
				),
				$this->module_id . '-comments' => array(
					'endpoint' => $this->module_info['module_id'] . '/comments',
					'name' => sprintf( __( '%s Comments', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => '',
					'methods' => array(
						'post' => array($this, 'getComments'), // callback function
					),
					'permissions' => function ( $request ) {
						$user = $this->helpers->getApiUserInfo( $request );

						return ( ! empty( $user )) ? true : false;
					},
				),
				$this->module_id . '-add-comment' => array(
					'endpoint' => $this->module_info['module_id'] . '/add-comment',
					'name' => sprintf( __( '%s Comments', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => '',
					'methods' => array(
						'post' => array($this, 'addComment'), // callback function
					),
					'permissions' => function ( $request ) {
						$user = $this->helpers->getApiUserInfo( $request );

						return ( ! empty( $user )) ? true : false;
					},
				),
				$this->module_id . '-update-comment' => array(
					'endpoint' => $this->module_info['module_id'] . '/update-comment',
					'name' => sprintf( __( '%s Rate Comment', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => __( 'Updates comment rating.', 'addon-supportezzy' ),
					'methods' => array(
						'post' => array($this, 'updateCommentInfo'), // callback function
					),
					'permissions' => function ( $request ) {
						$user = $this->helpers->getApiUserInfo( $request );

						return ( ! empty( $user )) ? true : false;
					},
				),
				$this->module_id . '-verify-license-key' => array(
					'endpoint' => $this->module_info['module_id'] . '/verify-license-key',
					'name' => sprintf( __( '%s Verify Envato', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => __( 'Verify envato purchase code', 'addon-supportezzy' ),
					'methods' => array(
						'post' => array($this, 'verifyLicenseKey'), // callback function
					),
					'permissions' => function ( $request ) {
						return true;
						$user = $this->helpers->getApiUserInfo( $request );

						return ( ! empty( $user )) ? true : false;
					},
				),

				$this->module_id . '-send-skype-invite' => array(
					'endpoint' => $this->module_info['module_id'] . '/send-skype-invite',
					'name' => sprintf( __( '%s Send Skype Invite', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => '',
					'methods' => array(
						'post' => array($this, 'sendSkypeInvite'), // callback function
					),
					'permissions' => function ( $request ) {
						$user = $this->helpers->getApiUserInfo( $request );

						return ( ! empty( $user )) ? true : false;
					},
				),
				$this->module_id . '-request-additional-info-update' => array(
					'endpoint' => $this->module_info['module_id'] . '/request-additional-info-update',
					'name' => sprintf( __( '%s Request Additional Info Update', 'addon-supportezzy' ), $this->module_info['module_name'] ),
					'description' => '',
					'methods' => array(
						'post' => array($this, 'requestAdditionalInfoUpdate'), // callback function
					),
					'permissions' => function ( $request ) {
						$user = $this->helpers->getApiUserInfo( $request );

						return ( ! empty( $user )) ? true : false;
					},
				)
			);
			add_filter( 'cjaddons_register_api_route', array($this, 'registerRoute') );
		}

		public function registerRoute( $routes ) {
			$routes = array_merge( $routes, $this->routes );

			return $routes;
		}

		public function createTicket( $request ) {
			$errors = array();
			$user_info = $this->helpers->getApiUserInfo( $request );
			$post_data = $request->get_params();

			foreach( $post_data as $key => $value ) {
				if( ! is_array( $value ) ) {
					$post_data[ $key ] = str_replace( '+', ' ', wp_slash( $value ) );
				}
			}
			if( isset( $post_data['post_author'] ) && $post_data['post_author'] == '' ) {
				$errors['post_author'] = __( 'Please select a client account for which you would like to create this ticket.', 'addon-supportezzy' );
			}

			// check if user_email is specified.
			$author_info = array();
			if( isset( $request['user_email'] ) ) {
				$author_email = $request['user_email'];
				$author_info = $this->helpers->userInfo( $author_email );
				if( empty( $author_info ) ) {
					$author_login = $this->helpers->uniqueUsername( $author_email );
					$author_pass = wp_generate_password( 12, true );
					$author_data = array(
						'first_name' => (isset( $request['first_name'] )) ? $request['first_name'] : '',
						'last_name' => (isset( $request['last_name'] )) ? $request['last_name'] : '',
					);

					// new user notification settings
					$notify = $this->helpers->savedOption( 'cjsupport_send_new_user_email' );
					if( $notify == '' ) {
						$notify = 'both';
					}
					if( $notify == 'none' ) {
						$notify = null;
					}

					$this->helpers->createNewAccount( $author_login, $author_email, $author_pass, $author_data, true, $notify );
					$author_info = $this->helpers->userInfo( $author_login );
				}
			}

			if( isset( $author_info['cjaddons_user_salt'] ) && $author_info['cjaddons_user_salt'] != '' ) {
				$salt = base64_decode( $author_info['cjaddons_user_salt'] );
				$this->helpers->loginWithSalt( $author_info['ID'], $salt );
			}
			$author_info = $this->helpers->userInfo( $author_info['ID'] );

			$required_fields = array('first_name', 'last_name', 'user_email', 'post_title', 'post_content');
			foreach( $required_fields as $key => $required_field ) {
				if( ! isset( $request[ $required_field ] ) ) {
					$errors['required_fields'] = __( 'Missing required fields.', 'addon-supportezzy' );
				}
			}

			if( isset( $request['post_title'] ) && $request['post_title'] == '' ) {
				$errors['post_title'] = __( 'You must specify ticket title.', 'addon-supportezzy' );
			}
			if( isset( $request['post_content'] ) && $request['post_content'] == '' ) {
				$errors['post_content'] = __( 'You must specify ticket description.', 'addon-supportezzy' );
			}

			if( isset( $request['g-recaptcha-response'] ) ) {
				$recaptcha = $this->helpers->reCaptcha();

				if( ! $recaptcha->isValid( $request['g-recaptcha-response'] ) ) {
					$errors['cjsupport_google_recaptcha'] = __( 'You must verify that you are human.', 'addon-supportezzy' );
				}
			}

			// form builder checks
			if( isset( $request['form_builder_form_id'] ) && $request['form_builder_form_id'] != '' && class_exists( 'cjaddons_form_builder_helpers' ) ) {
				$form_builder_helpers = cjaddons_form_builder_helpers::getInstance();
				$form_id = $request['form_builder_form_id'];
				$form_info = $this->helpers->postInfo( $form_id );
				if( ! empty( $form_info ) ) {
					if( isset( $form_info['_form_fields'] ) ) {
						$form_fields = $form_builder_helpers->getFormFields( $form_id );
						$validation_rules = array();
						foreach( $form_fields as $key => $form_field ) {
							if( isset( $form_field['validation_rules'] ) ) {
								$validation_rules[ 'form_builder_' . $form_field['id'] ] = $form_builder_helpers->prepareValidationRules( $form_field['validation_rules'] );
							}
						}
						$form_options = array();
						foreach( $form_fields as $key => $field ) {
							$form_options[ 'form_builder_' . $field['id'] ] = $field;
							$form_options[ 'form_builder_' . $field['id'] ]['id'] = 'form_builder_' . $field['id'];
						}
						$validation_errors = $this->helpers->validateFormWithGump( $post_data, $validation_rules, $form_options, 'messages' );
						if( ! empty( $validation_errors ) ) {
							$errors = $validation_errors;
						}

						if( isset( $form_options['form_builder_qna_answer'] ) && isset( $form_options['form_builder_qna_answer']['answer'] ) ) {
							if( isset( $post_data['form_builder_qna_answer'] ) && $post_data['form_builder_qna_answer'] != $form_options['form_builder_qna_answer']['answer'] ) {
								$errors['form_builder_qna_answer'] = __( 'Invalid answer, please check and try again.', 'addon-supportezzy' );
							}
						}
					}
				}
			}

			$envato_purchase_code = '';
			if( isset( $post_data['form_builder_verify-license-key'] ) && $post_data['form_builder_verify-license-key'] != '' ) {
				$envato = cjaddons_supportezzy_envato::getInstance();
				$response = $envato->api( 'get', 'v3/market/author/sale?code=' . $post_data['form_builder_verify-license-key'] );
				$response = json_decode( $response, 1 );
				if( isset( $response['error'] ) ) {
					$errors['form_builder_verify-license-key'] = $response['description'];
				} else {
					$envato_purchase_code = $post_data['form_builder_verify-license-key'];
				}
			}

			// if errors return api error
			if( ! empty( $errors ) ) {
				$data = array(
					'messages' => implode( '<br>', $errors ),
					'error_fields' => array_keys( $errors ),
				);

				return $this->helpers->apiError( $request, 206, implode( '<br>', $errors ), 206, $data );
			}

			$new_ticket_data = array(
				'post_title' => wp_slash( trim( $post_data['post_title'] ) ),
				'post_name' => sanitize_title( trim( $post_data['post_title'] ) ),
				'post_type' => 'cjsupport',
				'post_content' => wp_slash( $post_data['post_content'] ),
				'post_author' => (isset( $request['post_author'] ) && $request['post_author'] != '') ? $request['post_author'] : $author_info['ID'],
				'post_status' => 'publish',
			);

			$new_ticket_data['meta_input']['_uid'] = strtoupper( $this->helpers->uniqueString() );
			$new_ticket_data['meta_input']['_priority'] = (isset( $request['_priority'] )) ? $request['_priority'] : 24;
			$new_ticket_data['meta_input']['_department'] = (isset( $request['_department'] )) ? $request['_department'] : '';
			$new_ticket_data['meta_input']['_product'] = (isset( $request['_product'] )) ? $request['_product'] : '';
			$new_ticket_data['meta_input']['cjsupport_migrated'] = 1;

			$new_post_id = wp_insert_post( $new_ticket_data );

			if( $envato_purchase_code !== '' ) {
				update_post_meta( $new_post_id, 'envato_purchase_code', $envato_purchase_code );
			}

			if( isset( $request['_department'] ) && $request['_department'] != '' && $request['_department'] != 'all' ) {
				wp_set_object_terms( $new_post_id, $request['_department'], 'cjsupport_departments', false );
			}
			if( isset( $request['_product'] ) && $request['_product'] != '' && $request['_product'] != 'all' ) {
				wp_set_object_terms( $new_post_id, $request['_product'], 'cjsupport_products', false );
			}

			if( isset( $request['attachments'] ) && ! empty( $request['attachments'] ) ) {
				$data['attachments'] = $request['attachments'];
				update_post_meta( $new_post_id, '_attachments', $request['attachments'] );
			}

			if( isset( $request['additional_data'] ) && is_array( $request['additional_data'] ) && ! empty( $request['additional_data'] ) ) {
				foreach( $request['additional_data'] as $a_key => $a_value ) {
					update_post_meta( $new_post_id, $a_key, $a_value );
				}
			}

			$ticket_info = $this->helpers->postInfo( $new_post_id );
			$assign_to = $this->helpers->assignTicketTo( $ticket_info );
			update_post_meta( $new_post_id, '_assigned_to', '' );

			if( ! is_array( $assign_to ) ) {
				update_post_meta( $new_post_id, '_assigned_to', '' );
			}
			if( is_array( $assign_to ) && ! empty( $assign_to ) ) {
				update_post_meta( $new_post_id, '_assigned_to', $assign_to );
			}

			if( ! empty( $user_info ) && in_array( $user_info['ID'], $this->helpers->supportAgentsArray() ) ) {
				update_post_meta( $new_post_id, '_assigned_to', array($user_info['ID'] => $user_info['user_login']) );
			}

			$new_ticket_info = $this->helpers->postInfo( $new_post_id );
			$new_ticket_keys = array_keys( $new_ticket_info );

			foreach( $post_data as $key => $value ) {
				if( ! in_array( $key, $new_ticket_keys ) ) {
					update_post_meta( $new_post_id, $key, $value );
				}
			}

			$data['access_token'] = $author_info['access_token'];
			$data['ticket_id'] = $new_post_id;

			// send emails
			$is_imap = (isset( $request['_cjsupport_mail_id'] )) ? true : false;
			$this->helpers->processNewTicketEmails( $new_post_id, $is_imap );

			return $this->helpers->apiResponse( $request, $data );
		}

		public function getTickets( $request ) {
			$data = array();
			$user_info = $this->helpers->getApiUserInfo( $request );
			$user_is = $this->helpers->userIs( $user_info );

			$all_posts = array();
			$total_inbox = array();
			$total_yours = array();
			$total_not_assigned = array();
			$total_awaiting_response = array();
			$awaiting_response_posts = array();
			$total_delayed_posts = array();
			$delayed_posts = array();

			$all_tickets = get_posts( array(
				'post_type' => 'cjsupport',
				'post_status' => 'publish',
				'posts_per_page' => - 1,
			) );

			foreach( $all_tickets as $key => $ticket ) {
				$ticket_info = $this->helpers->ticketInfo( $ticket->ID, $user_info );
				$assigned_to_ids = array();
				if( isset( $ticket_info['assigned_to'] ) ) {
					$assigned_to_ids = array_keys( $ticket_info['assigned_to'] );
				}

				// total inbox
				if( $ticket_info['post_status'] == 'publish' ) {
					if( $user_is == 'admin' || $user_is == 'agent' ) {
						$total_inbox[] = 1;
					}
					if( $user_is == 'client' && $ticket_info['client_info']['ID'] == $user_info['ID'] ) {
						$total_inbox[] = 1;
					}
				}
				// total not assigned
				if( ! isset( $ticket_info['assigned_to'] ) ) {
					$total_not_assigned[] = 1;
				}
				// total yours
				if( $user_is != 'client' && in_array( $user_info['ID'], $assigned_to_ids ) ) {
					$total_yours[] = 1;
				}
				// total awaiting response
				if( isset( $ticket_info['awaiting_response'] ) && $ticket_info['awaiting_response'] > 0 ) {
					if( $user_is == 'client' && $user_info['ID'] == $ticket_info['client_info']['ID'] ) {
						$total_awaiting_response[] = 1;
						$awaiting_response_posts[] = $ticket_info;
					}
					if( $user_is != 'client' && in_array( $user_info['ID'], $assigned_to_ids ) ) {
						$total_awaiting_response[] = 1;
						$awaiting_response_posts[] = $ticket_info;
					}

					if( $ticket_info['priority_delayed'] > 0 && in_array( $user_info['ID'], $assigned_to_ids ) ) {
						$total_delayed_posts[] = 1;
						$delayed_posts[] = $ticket_info;
					}
				}

				$all_posts[] = $ticket_info;
			}

			$data['filter_bar_numbers']['inbox'] = (int) count( $total_inbox );
			$data['filter_bar_numbers']['yours'] = (int) count( $total_yours );
			$data['filter_bar_numbers']['not_assigned'] = (int) count( $total_not_assigned );
			$data['filter_bar_numbers']['awaiting_response'] = (int) count( $total_awaiting_response );
			$data['filter_bar_numbers']['delayed'] = (int) count( $total_delayed_posts );

			$query_args = array(
				'post_type' => 'cjsupport',
				'posts_per_page' => 10,
				'orderby' => 'post_date',
				'order' => 'DESC',
			);

			foreach( $request['query'] as $k => $v ) {
				$query_args[ $k ] = $v;
			}

			if( isset( $request['query']['_assigned_to'] ) && $request['query']['_assigned_to'] != '' ) {
				$query_args['meta_query'][] = array(
					'key' => '_assigned_to',
					'value' => $request['query']['_assigned_to'],
					'compare' => 'LIKE',
				);
			}
			if( isset( $request['query']['_priority'] ) && $request['query']['_priority'] != '' ) {
				$query_args['meta_query'][] = array(
					'key' => '_priority',
					'value' => $request['query']['_priority'],
					'compare' => 'LIKE',
				);
			}
			if( isset( $request['query']['_department'] ) && $request['query']['_department'] != '' ) {
				$query_args['tax_query'][] = array(
					'taxonomy' => 'cjsupport_departments',
					'field' => 'slug',
					'terms' => array($request['query']['_department']),
				);
			}
			if( isset( $request['query']['_product'] ) && $request['query']['_product'] != '' ) {
				$query_args['tax_query'][] = array(
					'taxonomy' => 'cjsupport_products',
					'field' => 'slug',
					'terms' => array($request['query']['_product']),
				);
			}
			if( isset( $request['query']['search'] ) && $request['query']['search'] != '' ) {
				$query_args['s'] = $request['query']['search'];
			}
			if( isset( $request['query']['post_status'] ) && $request['query']['post_status'] != '' ) {
				if( $request['query']['post_status'] == 'any' ) {
					$query_args['post_status'] = array('publish', 'closed');
				} else {
					$query_args['post_status'] = $request['query']['post_status'];
				}
			}

			$start_date = (isset( $request['query']['_start_date'] )) ? $request['query']['_start_date'] : '';
			$start_date = str_replace( '+', ' ', $start_date );

			$end_date = (isset( $request['query']['_end_date'] )) ? $request['query']['_end_date'] : '';
			$end_date = str_replace( '+', ' ', $end_date );

			if( $start_date != '' || $end_date != '' ) {
				$query_args['date_query'] = array(
					'after' => $start_date,
					'before' => $end_date,
					'inclusive' => true,
				);
			}

			if( isset( $request['query']['_uid'] ) && $request['query']['_uid'] != '' ) {
				$query_args = array(
					'post_type' => 'cjsupport'
				);
				$query_args['meta_query'][] = array(
					'key' => '_uid',
					'value' => $request['query']['_uid'],
					'compare' => '=',
				);
			}

			$query_args['paged'] = (isset( $query_args['paged'] )) ? $query_args['paged'] : 1;


			if( isset( $request['query']['save_filter'] ) && $request['query']['save_filter'] != '' ) {
				$filter_name = urldecode( $request['query']['save_filter'] );
				$user_filters = get_user_meta( $user_info['ID'], 'cjsupport_tickets_filters', true );
				if( $user_filters == '' ) {
					$user_filters = array();
				}
				$user_filters[ $filter_name ] = $query_args;
				$query_args['query_name'] = 'Custom';
				update_user_meta( $user_info['ID'], 'cjsupport_tickets_filters', $user_filters );
			}

			$data['posts'] = array();
			$data['query_args'] = $query_args;

			$the_query = new WP_Query( $query_args );
			$posts = array();
			if( $the_query->have_posts() ) {
				$count = - 1;
				while( $the_query->have_posts() ) {
					$count ++;
					$the_query->the_post();
					global $post;
					$ticket_info = $this->helpers->ticketInfo( $post->ID, $user_info );
					$posts[ $count ] = $ticket_info;
				}
				wp_reset_postdata();
				if( is_array( $posts ) && ! empty( $posts ) ) {
					$data['posts'] = $posts;
					$data['query_args'] = $query_args;
					$data['post_count'] = $the_query->post_count;
					$data['total_posts'] = (int) $the_query->found_posts;

					$data['pagination'] = array();
					// pagination data
					$total_pages = $the_query->max_num_pages;
					$current_page = (int) $the_query->query['paged'];
					$next_page = $the_query->query['paged'] + 1;
					$previous_page = $the_query->query['paged'] - 1;
					if( $next_page > $total_pages ) {
						$next_page = null;
					}
					if( $previous_page <= 0 ) {
						$previous_page = null;
					}
					$data['pagination']['total_pages'] = $total_pages;
					$data['pagination']['current_page'] = $current_page;
					$data['pagination']['next_page'] = $next_page;
					$data['pagination']['previous_page'] = $previous_page;
				}
			}
			// awaiting response posts
			if( isset( $request['query']['awaiting_response'] ) && $request['query']['awaiting_response'] == 1 ) {
				$data['posts'] = array();
				$data['posts'] = $awaiting_response_posts;
				$data['pagination'] = array();
			}
			// delayed posts
			if( isset( $request['query']['delayed'] ) && $request['query']['delayed'] == 1 ) {
				$data['posts'] = array();
				$data['posts'] = $delayed_posts;
				$data['pagination'] = array();
			}

			return $this->helpers->apiResponse( $request, $data );
		}

		public function getTicket( $request ) {
			$user_info = $this->helpers->getApiUserInfo( $request );
			$data = $this->helpers->ticketInfo( $request['ticket_id'], $user_info );
			$ticket_content = strip_tags( $data['post_content'], '<p><a><img><br><pre><code><b><strong><a>' );
			//$ticket_content = preg_replace( '#<br />(\s*<br />)+#', '<br />', $ticket_content );
			$ticket_content = str_replace( array('&nbsp;', "&nbsp;", "\n", "\t"), '', $ticket_content );
			$data['post_content'] = $ticket_content;

			return $this->helpers->apiResponse( $request, $data );
		}

		public function ticketsUpdateData( $request ) {
			$time = current_time( 'mysql', 0 );
			$user_info = $this->helpers->getApiUserInfo( $request );
			$ticket_info = $this->helpers->ticketInfo( $request['post_id'], $user_info );

			if( isset( $request['post_data']['post_status'] ) && $request['post_data']['post_status'] == 'closed' && $ticket_info['post_status'] != 'closed' ) {
				// add note
				update_post_meta( $request['post_id'], 'disable_auto_close', 1 );
				$message = sprintf( __( '%s closed the ticket.', 'addon-supportezzy' ), $user_info['display_name'] );
				$comment_data = array(
					'comment_post_ID' => $ticket_info['ID'],
					'comment_author' => $user_info['user_login'],
					'comment_author_email' => $user_info['user_email'],
					'comment_content' => $message,
					'comment_type' => 'note',
					'user_id' => $user_info['ID'],
					'comment_date' => $time,
					'comment_approved' => 1,
				);
				wp_insert_comment( $comment_data );
			}

			if( isset( $request['post_data']['post_status'] ) && $request['post_data']['post_status'] == 'publish' && $ticket_info['post_status'] != 'publish' ) {
				// add note
				update_post_meta( $request['post_id'], 'disable_auto_close', 1 );
				$message = sprintf( __( '%s opened the ticket.', 'addon-supportezzy' ), $user_info['display_name'] );
				$comment_data = array(
					'comment_post_ID' => $ticket_info['ID'],
					'comment_author' => $user_info['user_login'],
					'comment_author_email' => $user_info['user_email'],
					'comment_content' => $message,
					'comment_type' => 'note',
					'user_id' => $user_info['ID'],
					'comment_date' => $time,
					'comment_approved' => 1,
				);
				wp_insert_comment( $comment_data );
			}

			// update assigned users
			if( isset( $request['post_data']['_assigned_to'] ) ) {
				// user added
				if( is_array( $ticket_info['assigned_to'] ) && count( $ticket_info['assigned_to'] ) < count( $request['post_data']['_assigned_to'] ) ) {
					$new_users = array();
					foreach( $request['post_data']['_assigned_to'] as $u_key => $u_value ) {
						if( ! in_array( $u_key, array_keys( $ticket_info['assigned_to'] ) ) ) {
							$new_user_display_names = $this->helpers->userInfo( $u_key )['display_name'];
							$new_users[] = $new_user_display_names;
						}
					}
					$message = sprintf( __( '%s added %s', 'addon-supportezzy' ), $user_info['display_name'], implode( ', ', $new_users ) );
					$comment_data = array(
						'comment_post_ID' => $ticket_info['ID'],
						'comment_author' => $user_info['user_login'],
						'comment_author_email' => $user_info['user_email'],
						'comment_content' => $message,
						'comment_type' => 'note',
						'user_id' => $user_info['ID'],
						'comment_date' => $time,
						'comment_approved' => 1,
					);
					wp_insert_comment( $comment_data );
				}

				// user removed
				if( is_array( $ticket_info['assigned_to'] ) && count( $ticket_info['assigned_to'] ) > count( $request['post_data']['_assigned_to'] ) ) {
					$removed_users = array();
					foreach( $ticket_info['assigned_to'] as $u_key => $u_value ) {
						if( ! in_array( $u_key, array_keys( $request['post_data']['_assigned_to'] ) ) ) {
							$new_user_display_names = $this->helpers->userInfo( $u_key )['display_name'];
							$removed_users[] = $new_user_display_names;
						}
					}
					$message = sprintf( __( '%s removed %s', 'addon-supportezzy' ), $user_info['display_name'], implode( ', ', $removed_users ) );
					$comment_data = array(
						'comment_post_ID' => $ticket_info['ID'],
						'comment_author' => $user_info['user_login'],
						'comment_author_email' => $user_info['user_email'],
						'comment_content' => $message,
						'comment_type' => 'note',
						'user_id' => $user_info['ID'],
						'comment_date' => $time,
						'comment_approved' => 1,
					);
					wp_insert_comment( $comment_data );
				}
			}

			$this->helpers->updatePostInfo( $request['post_id'], $request['post_data'] );
			$data['success'] = 1;

			return $this->helpers->apiResponse( $request, $data );
		}

		public function getComments( $request ) {
			$data = array();
			$number_of_comments = 3;
			$query_args = array(
				'status' => 'all',
				'number' => $number_of_comments,
				'orderby' => 'comment_date',
				'order' => 'DESC',
			);

			if( isset( $request['query_args'] ) && is_array( $request['query_args'] ) && ! empty( $request['query_args'] ) ) {
				foreach( $request['query_args'] as $key => $query_arg ) {
					$query_args[ $key ] = $query_arg;
				}
			}

			$data['query_args'] = $query_args;

			$total_query_args = $query_args;
			$total_query_args['number'] = '';

			$comments = get_comments( $query_args );
			$total_comments = get_comments( $total_query_args );

			$data['total_comments'] = count( $total_comments );
			$data['hidden_comments'] = count( $total_comments ) - count( $comments );

			if( ! empty( $comments ) ) {
				foreach( $comments as $key => $comment ) {
					$data['comments'][ $comment->comment_ID ] = $this->helpers->commentInfo( $comment->comment_ID, array(), explode( ',', $this->helpers->userInfoDefaultFields() ) );
					$comment_content = strip_tags( $data['comments'][ $comment->comment_ID ]['comment_content'], '<p><a><img><br><pre><code><b><strong><a>' );
					//$comment_content = preg_replace( '#<br />(\s*<br />)+#', '<br />', $comment_content );
					$comment_content = str_replace( array('&nbsp;'), '', $comment_content );
					//$comment_content = preg_replace('/(^|\s)\{/faq:([0-9]+:+([A-Za-z0-9\s.?!@#$%^&*()_+]+))/i','', $comment_content);
					$data['comments'][ $comment->comment_ID ]['comment_content'] = $comment_content;
				}
			}

			return $this->helpers->apiResponse( $request, $data );
		}

		public function addComment( $request ) {
			$errors = array();
			if( $request['comment_content'] == '' ) {
				$errors['comment_content'] = __( 'Comment field cannot be blank.', 'addon-supportezzy' );
			}

			if( ! empty( $errors ) ) {
				$data = array();
				$data['errors'] = implode( '<br>', $errors );

				return $this->helpers->apiResponse( $request, $data );
			} else {
				$time = current_time( 'mysql', 0 );
				$api_user_info = $this->helpers->getApiUserInfo( $request );
				$comment_content = $request['comment_content'];
				$comment_content = $this->helpers->parseUserTagString( $comment_content );
				$comment_content = $this->helpers->parseFaqString( $comment_content );

				// update ticket assignments
				preg_match_all( '/(^|\s)@([a-z0-9_]+)/i', $request['comment_content'], $match );
				if( is_array( $match[0] ) ) {
					$assigned_to = get_post_meta( $request['comment_post_ID'], '_assigned_to', true );
					foreach( $match[0] as $key => $match ) {
						$user_login = str_replace( '@', '', $match );
						$user_login = trim( $user_login );
						$assigned_user_info = $this->helpers->userInfo( $user_login );
						if( ! empty( $assigned_user_info ) ) {
							$assigned_to[ $assigned_user_info['ID'] ] = $assigned_user_info['user_login'];
						}
					}
					update_post_meta( $request['comment_post_ID'], '_assigned_to', $assigned_to );
				}

				$data = array(
					'comment_post_ID' => $request['comment_post_ID'],
					'comment_author' => $api_user_info['user_login'],
					'comment_author_email' => $api_user_info['user_email'],
					'comment_content' => wp_slash( $comment_content ),
					'comment_type' => $request['comment_type'],
					'user_id' => $api_user_info['ID'],
					'comment_date' => $time,
					'comment_approved' => 1,
				);

				$comment_id = wp_insert_comment( $data );
				$data['success'] = $comment_id;

				// attachments
				if( isset( $request['attachments'] ) && ! empty( $request['attachments'] ) ) {
					$data['attachments'] = $request['attachments'];
					update_comment_meta( $comment_id, '_attachments', $request['attachments'] );
				}

				// archive ticket
				if( isset( $request['archive_ticket'] ) && $request['archive_ticket'] == 1 ) {
					$this->helpers->dbUpdate( 'posts', array('post_status' => 'closed'), 'ID', $request['comment_post_ID'] );
					$message = sprintf( __( '%s closed the ticket.', 'addon-supportezzy' ), $api_user_info['display_name'] );
					$comment_data = array(
						'comment_post_ID' => $request['comment_post_ID'],
						'comment_author' => $api_user_info['user_login'],
						'comment_author_email' => $api_user_info['user_email'],
						'comment_content' => $message,
						'comment_type' => 'note',
						'user_id' => $api_user_info['ID'],
						'comment_date' => $time,
						'comment_approved' => 1,
					);
					$comment_id = wp_insert_comment( $comment_data );
				}


				$this->helpers->processNewCommentEmails( $comment_id, $api_user_info );
			}

			return $this->helpers->apiResponse( $request, $data );
		}

		public function updateCommentInfo( $request ) {
			$data = $this->helpers->updateCommentInfo( $request['comment_id'], $request['data'] );

			return $this->helpers->apiResponse( $request, $data );
		}

		public function verifyLicenseKey( $request ) {
			$user_info = $this->helpers->getApiUserInfo( $request );
			$envato = cjaddons_supportezzy_envato::getInstance();
			$gumroad = cjaddons_supportezzy_gumroad::getInstance();

			$ticket_info = $this->helpers->ticketInfo( $request['ticket_id'], $user_info );

			delete_post_meta( $ticket_info['ID'], 'envato_purchase_code' );
			delete_post_meta( $ticket_info['ID'], 'envato_purchase_info' );

			$product_slug = array_keys( $ticket_info['products'] );
			$verification_type = $ticket_info['verification_type'];
			$product_slug = str_replace( array('envato-', 'gumroad-'), '', $product_slug[0] );

			if( $verification_type == 'envato' ) {
				$response = $envato->api( 'get', 'v3/market/author/sale?code=' . $request['code'] );
				$response = json_decode( $response );
				if( isset( $response->error ) ) {
					$data['error'] = $response->description;
					update_post_meta( $ticket_info['ID'], 'envato_purchase_code', '' );
					update_post_meta( $ticket_info['ID'], 'envato_purchase_info', '' );

					return $this->helpers->apiResponse( $request, $data );
				}

				if( ! isset( $response->error ) ) {
					$product_slug = 'envato-' . $response->item->id;
					if( in_array( $product_slug, array_keys( $ticket_info['products'] ) ) ) {
						update_post_meta( $ticket_info['ID'], 'envato_purchase_info', $response );
						update_post_meta( $ticket_info['ID'], 'envato_purchase_code', $request['code'] );
						update_post_meta( $ticket_info['ID'], 'must_verify', 0 );
						$data['success'] = 1;

						return $this->helpers->apiResponse( $request, $data );
					} else {
						$data['error'] = __( 'Invalid purchase code! <br>This code belongs to another product.', 'addon-supportezzy' );

						return $this->helpers->apiResponse( $request, $data );
					}
				}
			}

			if( $verification_type == 'gumroad' ) {
				$response = $gumroad->verifyLicense( $product_slug, $request['code'] );

				if( isset( $response['error'] ) ) {
					$data['error'] = $response['error'];
					update_post_meta( $ticket_info['ID'], 'envato_purchase_code', '' );
					update_post_meta( $ticket_info['ID'], 'envato_purchase_info', '' );

					return $this->helpers->apiResponse( $request, $data );
				}

				$purchase_info = $response['success'];
				$purchase_info['license'] = $purchase_info['product_name'];
				if( isset( $purchase_info['chargebacked'] ) ) {
					$purchase_info['license'] = __( 'Gumroad Single Install License', 'addon-supportezzy' );
				}
				if( isset( $purchase_info['subscription_cancelled_at'] ) ) {
					$purchase_info['license'] = __( 'Gumroad Subscription', 'addon-supportezzy' );
				}
				$purchase_info['supported_until'] = '2099-01-01 00:00:00';

				update_post_meta( $ticket_info['ID'], 'envato_purchase_info', $purchase_info );
				update_post_meta( $ticket_info['ID'], 'envato_purchase_code', $request['code'] );
				update_post_meta( $ticket_info['ID'], 'must_verify', 0 );
				$data['success'] = 1;

				return $this->helpers->apiResponse( $request, $data );
			}
		}

		public function toggleTicketStars( $request ) {
			$user_info = $this->helpers->getApiUserInfo( $request );
			$ticket_stars = get_post_meta( $request['ticket_id'], '_starred_by', true );
			if( ! is_array( $ticket_stars ) ) {
				$ticket_stars = array();
			}
			if( $request['action'] == 'add' ) {
				$ticket_stars[ $user_info['ID'] ] = $user_info['user_email'];
			}
			if( $request['action'] == 'remove' ) {
				unset( $ticket_stars[ $user_info['ID'] ] );
			}
			update_post_meta( $request['ticket_id'], '_starred_by', $ticket_stars );
			$data = $this->helpers->ticketInfo( $request['ticket_id'], $user_info );

			return $this->helpers->apiResponse( $request, $data );
		}

		public function sendSkypeInvite( $request ) {
			$ticket_data = $request->get_params();
			$api_user_info = $this->helpers->getApiUserInfo( $request );
			$skype_link = $this->helpers->queryString( site_url() ) . 'cjaddons-goto=' . $ticket_data['skype_conversation_link'];
			$comment_content = sprintf( __( '%s invited %s on Skype. <a href="%s">Click here</a> to join the conversation.', 'addon-supportezzy' ), $api_user_info['display_name'], $ticket_data['client_info']['display_name'], $skype_link );
			$time = current_time( 'mysql', 0 );
			$comment_data = array(
				'comment_post_ID' => $ticket_data['ID'],
				'comment_author' => $api_user_info['user_login'],
				'comment_author_email' => $api_user_info['user_email'],
				'comment_content' => wp_slash( $comment_content ),
				'comment_type' => 'note',
				'user_id' => $api_user_info['ID'],
				'comment_date' => $time,
				'comment_approved' => 1,
			);
			$comment_id = wp_insert_comment( $comment_data );
			$company_name = $this->helpers->savedOption( 'cjsupport_company_name' );
			$reply_to_address = $this->helpers->getReplyToAddress( $ticket_data );
			$email_message = sprintf( __( '%s invited you to chat on Skype<br><a href="%s">Click here</a> to join conversation.', 'addon-supportezzy' ), $api_user_info['display_name'], $skype_link );
			$subject = '[' . $ticket_data['uid'] . '] ' . __( 'Skype invitation!', 'addons-supportezzy' );
			$email_data = array(
				'to' => $ticket_data['client_info']['user_email'],
				'from_name' => $company_name,
				'from_email' => $reply_to_address,
				'subject' => '[' . $ticket_data['uid'] . '] ' . __( 'Skype invitation!', 'addons-supportezzy' ),
				'message' => $email_message,
			);
			$this->helpers->sendEmail( $email_data );
			$one_signal = cjaddons_supportezzy_one_signal::getInstance();
			$one_signal->sendUserNotification( array($ticket_data['client_info']['ID']), array('en' => $subject), array('url' => $ticket_data['ticket_url']) );
			$data['success'] = $email_message;

			return $this->helpers->apiResponse( $request, $data );
		}

		public function requestAdditionalInfoUpdate( $request ) {
			$ticket_data = $request->get_params();
			$api_user_info = $this->helpers->getApiUserInfo( $request );
			$update_link = $this->helpers->queryString( site_url() ) . 'cjaddons-goto=' . $ticket_data['skype_conversation_link'];
			$ticket_link = $ticket_data['ticket_url'];
			$comment_content = sprintf( __( '%s requested %s to update additional information. <a class="cj-open-update-additional-modal">Click here</a> to update.', 'addon-supportezzy' ), $api_user_info['display_name'], $ticket_data['client_info']['display_name'] );
			$time = current_time( 'mysql', 0 );
			$comment_data = array(
				'comment_post_ID' => $ticket_data['ID'],
				'comment_author' => $api_user_info['user_login'],
				'comment_author_email' => $api_user_info['user_email'],
				'comment_content' => wp_slash( $comment_content ),
				'comment_type' => 'note',
				'user_id' => $api_user_info['ID'],
				'comment_date' => $time,
				'comment_approved' => 1,
			);
			$comment_id = wp_insert_comment( $comment_data );
			$company_name = $this->helpers->savedOption( 'cjsupport_company_name' );
			$reply_to_address = $this->helpers->getReplyToAddress( $ticket_data );
			$email_message = sprintf( __( '%s requested you to update the additional information for this ticket.<br><a href="%s">Click here</a> to view the ticket.', 'addon-supportezzy' ), $api_user_info['display_name'], $ticket_link );
			$subject = '[' . $ticket_data['uid'] . '] ' . __( 'Skype invitation!', 'addons-supportezzy' );
			$email_data = array(
				'to' => $ticket_data['client_info']['user_email'],
				'from_name' => $company_name,
				'from_email' => $reply_to_address,
				'subject' => '[' . $ticket_data['uid'] . '] ' . __( 'Update request!', 'addons-supportezzy' ),
				'message' => $email_message,
			);
			$this->helpers->sendEmail( $email_data );
			$one_signal = cjaddons_supportezzy_one_signal::getInstance();
			$one_signal->sendUserNotification( array($ticket_data['client_info']['ID']), array('en' => $subject), array('url' => $ticket_data['ticket_url']) );
			$data['success'] = $email_message;

			return $this->helpers->apiResponse( $request, $data );
		}

	}

	cjaddons_rest_cjsupport_tickets::getInstance();
}