<?php
if( ! class_exists( 'cjaddons_supportezzy_form_builder_ext' ) ) {
	class cjaddons_supportezzy_form_builder_ext {
		private static $instance;
		public $helpers;

		public static function getInstance() {
			if( ! isset( self::$instance ) ) {
				self::$instance = new self();
			}

			return self::$instance;
		}

		public function __construct() {
			$this->helpers = cjaddons_helpers::getInstance();
			add_filter( 'cjaddons_form_builder_available_fields', array($this, 'availableFields'), 1, 1 );
		}

		public function availableFields( $available_form_fields ) {
			$available_form_fields['supportezzy'] = array(
				'title' => esc_attr__( 'WP SupportEzzy', 'addon-supportezzy' ),
				'state' => 'closed',
				'fields' => array(
					'verify-license-key' => array(
						'title' => esc_attr__( 'Verify License Key', 'addon-supportezzy' ),
						'supports' => 'uid|label|info|attributes|validations',
						'attributes' => array(
							'class' => array(
								'id' => esc_attr__( 'class', 'addon-supportezzy' ),
								'label' => esc_attr__( 'CSS Class', 'addon-supportezzy' ),
								'default' => '',
							),
							'style' => array(
								'id' => esc_attr__( 'style', 'addon-supportezzy' ),
								'label' => esc_attr__( 'Inline Styles', 'addon-supportezzy' ),
								'default' => '',
							),
						),
						'defaults' => array(
							'type' => 'text',
							'id' => 'verify-license-key',
							'label' => esc_attr__( 'License Key', 'addon-supportezzy' ),
							'uid_type' => 'text',
							'can_change_uid' => 'no',
						),
						'settings' => array(),
						'validation_rules' => array(
							'required' => 'yes'
						),
					),
				),
			);
			return $available_form_fields;
		}

	}

	cjaddons_supportezzy_form_builder_ext::getInstance();
}