<?php
$current_user = $this->helpers->getApiUserInfo( $request );
$user_roles = $this->helpers->userRole( $current_user['ID'] );
$all_agents = $this->helpers->supportAgentsArray('user_login');
$is_agent = (in_array( 'support_agent', $user_roles )) ? 1 : 0;
$is_client = ( ! in_array( 'support_agent', $user_roles ) && ! in_array( 'administrator', $user_roles )) ? 1 : 0;
$is_admin = (in_array( 'administrator', $user_roles )) ? 1 : 0;
$departments = $this->helpers->getTaxonomyArray( 'cjsupport_departments' );
$products = $this->helpers->getTaxonomyArray( 'cjsupport_products' );

$form_fields = array();

if( ! $is_client ) {
	$form_fields['author'] = array(
		'id' => 'author',
		'type' => 'auto-complete',
		'label' => __( 'Created By', 'addon-supportezzy' ),
		'params' => array(
			'class' => 'selectize',
		),
		'settings' => array(
			'url' => admin_url( 'admin-ajax.php' ) . '?action=cjaddons_query_users',
			'post_data' => array(
				'orderby' => 'login',
				'order' => 'ASC',
				'search' => '*input_query*',
			),
			'key_field' => 'ID',
			'value_field' => 'display_name',
			'search_field' => 'user_login',
		),
		'default' => '',
		'options' => '', // array in case of dropdown, checkbox and radio buttons
	);
}

$form_fields['search'] = array(
	'id' => 'search',
	'type' => 'text',
	'label' => __( 'Search keywords..', 'addon-supportezzy' ),
	'default' => '',
	'container_class' => 'cj-column cj-is-12',
	'options' => '',
);

$form_fields['_uid'] = array(
	'id' => '_uid',
	'type' => ( ! $is_client) ? 'text' : 'hidden',
	'label' => __( 'Ticket ID', 'addon-supportezzy' ),
	'default' => '',
	'container_class' => 'cj-column cj-is-6',
	'options' => '',
);

$form_fields['_assigned_to'] = array(
	'id' => '_assigned_to',
	'type' => ( ! $is_client) ? 'dropdown' : 'hidden',
	'label' => __( 'Assigned To', 'addon-supportezzy' ),
	'default' => '',
	'container_class' => 'cj-column cj-is-6',
	'options' => $all_agents,
);

$form_fields['post_status'] = array(
	'id' => 'post_status',
	'type' => 'dropdown',
	'label' => __( 'Search in', 'addon-supportezzy' ),
	'default' => 'any',
	'container_class' => 'cj-column cj-is-6',
	'options' => array(
		'any' => __( 'All Tickets', 'addon-supportezzy' ),
		'publish' => __( 'Inbox', 'addon-supportezzy' ),
		'closed' => __( 'Archives', 'addon-supportezzy' ),
	),
);
$form_fields['_priority'] = array(
	'id' => '_priority',
	'type' => 'dropdown',
	'label' => __( 'Priority', 'addon-supportezzy' ),
	'default' => '',
	'params' => array(
		'placeholder' => __( 'Select priority', 'addon-supportezzy' )
	),
	'container_class' => 'cj-column cj-is-6',
	'options' => $this->helpers->savedOption( 'cjsupport-tickets-priority' ),
);
if( $this->helpers->savedOption( 'cjsupport_show_departments' ) == 'yes' && is_array( $departments ) && ! empty( $departments ) ) {
	$form_fields['_department'] = array(
		'id' => '_department',
		'type' => ( ! $is_client) ? 'dropdown' : 'hidden',
		'label' => __( 'Select a department', 'addon-supportezzy' ),
		'info' => '',
		'default' => '',
		'options' => $departments,
	);
}
if( $this->helpers->savedOption( 'cjsupport_show_products' ) == 'yes' && is_array( $products ) && ! empty( $products ) ) {
	$form_fields['_product'] = array(
		'id' => '_product',
		'type' => ( ! $is_client) ? 'dropdown' : 'hidden',
		'label' => __( 'Select a product', 'addon-supportezzy' ),
		'default' => '',
		'options' => $this->helpers->getTaxonomyArray( 'cjsupport_products' ),
	);
}

$form_fields['_start_date'] = array(
	'id' => '_start_date',
	'type' => 'date',
	'label' => __( 'Submitted on or after', 'addon-supportezzy' ),
	'default' => '',
	'container_class' => 'cj-column cj-is-6',
	'options' => '',
);

$form_fields['_end_date'] = array(
	'id' => '_end_date',
	'type' => 'date',
	'label' => __( 'Submitted on or before', 'addon-supportezzy' ),
	'default' => '',
	'container_class' => 'cj-column cj-is-6',
	'options' => '',
);

$form_fields['save_filter'] = array(
	'id' => 'save_filter',
	'type' => 'text',
	'label' => __( 'Save this filter?', 'addon-supportezzy' ),
	'default' => '',
	'container_class' => 'cj-column cj-is-12',
	'params' => array(
		'class' => 'cj-is-info cj-mb-20',
		'placeholder' => __( 'Enter a unique name for this filter to save.', 'addon-supportezzy' ),
	),
	'options' => array('yes' => __( 'Yes', 'addon-supportezzy' )),
);
