<?php

if( ! class_exists( 'cjaddons_supportezzy_nav_menu_metabox' ) ) {
	class cjaddons_supportezzy_nav_menu_metabox {
		public $helpers;
		private static $instance;

		public static function getInstance() {
			if( ! isset( self::$instance ) ) {
				self::$instance = new self();
			}

			return self::$instance;
		}

		public function __construct() {
			$this->helpers = cjaddons_supportezzy_helpers::getInstance();
			//add_action( 'admin_init', array($this, 'init') );
			add_action( 'admin_init', array($this, 'navMenuMetaboxLinks'), 10 );
		}

		public function navMenuMetaboxLinks() {
			add_filter( 'cjaddons_nav_menu_metabox_links', function ( $links ) {

				$support_app_page_url = $this->helpers->getOptionPageUrl( 'cjsupport_page_app' );

				$links['cjaddons-supportezzy-title'] = array(
					'object_id' => 'cjaddons-metabox-supportezzy-heading',
					'label' => 'WP SupportEzzy',
					'type' => 'cjaddons-metabox-heading',
					'title' => '',
					'url' => '',
					'classes' => '',
				);

				if( $support_app_page_url != '' ) {
					$links['cjaddons-supportezzy-login-page'] = array(
						'object_id' => 'cjaddons-supportezzy-login-page',
						'label' => __( 'Support App Page Link', 'addon-supportezzy' ),
						'type' => 'custom',
						'title' => 'Support',
						'url' => $support_app_page_url,
						'classes' => '',
					);
				}

				return $links;
			}, 1 );
		}

	}

	cjaddons_supportezzy_nav_menu_metabox::getInstance();
}


