<?php
if( ! class_exists( 'cjaddons_supportezzy_woocommerce' ) ) {
	class cjaddons_supportezzy_woocommerce {
		private static $instance;
		public $helpers;

		public static function getInstance() {
			if( ! isset( self::$instance ) ) {
				self::$instance = new self();
			}

			return self::$instance;
		}

		public function __construct() {
			$this->helpers = cjaddons_supportezzy_helpers::getInstance();
			add_action( 'save_post', array($this, 'syncOnSave') );

			add_filter( 'woocommerce_account_menu_items', array($this, 'accountMenuItems'), 10, 1 );
			add_action( 'init', array($this, 'addMyAccountEndpoint') );
			add_action( 'woocommerce_account_cjsupport_endpoint', array($this, 'cjsupportEndpointContent') );
		}

		public function syncOnSave( $post_id ) {
			if( wp_is_post_revision( $post_id ) ) {
				return;
			}
			$post_type = get_post_type( $post_id );
			if( ! class_exists( 'WooCommerce' ) ) {
				return;
			}
			if( "product" != $post_type ) {
				return;
			}

			$this->helpers->syncWoocommerceProduct( $post_id );
		}

		public function accountMenuItems( $menu_links ) {

			if( $this->helpers->savedOption( 'cjsupport_woocommerce_my_account_link' ) == 'yes' ) {
				$new_items = array();
				$count = 0;
				foreach( $menu_links as $key => $link ) {
					$count ++;
					$new_items[ $key ] = $link;
					if( $count == (count( $menu_links ) - 1) ) {
						$new_items['cjsupport'] = __( 'Support', 'addon-supportezzy' );
					}
				}
			}else{
				$new_items = $menu_links;
			}

			return $new_items;
		}

		public function addMyAccountEndpoint() {
			if( $this->helpers->savedOption( 'cjsupport_woocommerce_my_account_link' ) == 'no' ) {
				return false;
			}
			add_rewrite_endpoint( 'cjsupport', EP_PAGES );
		}

		public function cjsupportEndpointContent() {
			if( $this->helpers->savedOption( 'cjsupport_woocommerce_my_account_link' ) == 'no' ) {
				return false;
			}
			echo do_shortcode('[cjaddons_supportezzy_app app_header="disable" frame_height="1024"]');
		}

	}

	cjaddons_supportezzy_woocommerce::getInstance();
}